VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PL_Internet"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const Agent = "Mozilla/4.0 (compatible; MSIE 5.0; Windows NT; DigExt)"
Private Const INTERNET_OPEN_TYPE_PRECONFIG = 0
Private Const INTERNET_OPEN_TYPE_DIRECT = 1
Private Const INTERNET_OPEN_TYPE_PROXY = 3
Private Const INTERNET_FLAG_RELOAD = &H80000000
Private Const INTERNET_FLAG_EXISITING_CONNECT = &H20000000
Private Const INTERNET_FILE_MOVE_BEGIN = 0
Private Const INTERNET_FILE_MOVE_CURRENT = 1
Private Const INTERNET_FILE_MOVE_END = 3

Private Declare Sub Sleep Lib "kernel32.dll" (ByVal dwMilliseconds As Long)
Private Declare Function InternetOpen Lib "wininet" Alias "InternetOpenA" (ByVal sAgent As String, ByVal lAccessType As Long, ByVal sProxyName As String, ByVal sProxyBypass As String, ByVal lFlags As Long) As Long
Private Declare Function InternetCloseHandle Lib "wininet" (ByVal hInet As Long) As Integer
Private Declare Function InternetReadFile Lib "wininet" (ByVal hFile As Long, ByVal sBuffer As String, ByVal lNumBytesToRead As Long, lNumberOfBytesRead As Long) As Integer
Private Declare Function InternetOpenUrl Lib "wininet" Alias "InternetOpenUrlA" (ByVal hInternetSession As Long, ByVal lpszUrl As String, ByVal lpszHeaders As String, ByVal dwHeadersLength As Long, ByVal dwFlags As Long, ByVal dwContext As Long) As Long
Private Declare Function InternetConnect Lib "wininet.dll" Alias "InternetConnectA" (ByVal hInternetSession As Long, ByVal lpszServerName As String, ByVal nProxyPort As Integer, ByVal lpszUserName As String, ByVal lpszPassword As String, ByVal dwService As Long, ByVal dwFlags As Long, ByVal dwContext As Long) As Long
Private Declare Function InternetSetFilePointer Lib "wininet.dll" (ByVal hFile As Long, ByVal lDistanceToMove As Long, ByVal pReserved As Long, ByVal dwMoveMethod As Long, ByVal dwContext As Long) As Long
Private Declare Function HttpOpenRequest Lib "wininet.dll" Alias "HttpOpenRequestA" (ByVal hHttpSession As Long, ByVal sVerb As String, ByVal sObjectName As String, ByVal sVersion As String, ByVal sReferer As String, ByVal something As Long, ByVal lFlags As Long, ByVal lContext As Long) As Long
Private Declare Function HttpSendRequest Lib "wininet.dll" Alias "HttpSendRequestA" (ByVal hHttpRequest As Long, ByVal sHeaders As String, ByVal lHeadersLength As Long, sOptional As Any, ByVal lOptionalLength As Long) As Long
Private Declare Function HttpQueryInfo Lib "wininet.dll" Alias "HttpQueryInfoA" (ByVal hHttpRequest As Long, ByVal lInfoLevel As Long, ByRef sBuffer As Any, ByRef lBufferLength As Long, ByRef lIndex As Long) As Long

Private Type crkUrl
    Dominio As String
    Pathfile As String
End Type: Private crkUrl As crkUrl

Private Type InfoFile
    Server As String
    UltimaModifica As String
    Dimensione As String
End Type: Private InfoFile As InfoFile

Private Type AbortFile
    UrlWEB As String
    ByteRecuperati As Long
End Type: Private AbortFile As AbortFile

Private ByteRecuperati As Long
Private m_RetValSessione As Long
Private m_StopDownload As Boolean
Private m_UrlFileWEB As String
Private m_ByteRecuperatiSuAbort As Long

Event Ricevuti(ByVal ByteRecuperati As Long)

Private Sub Class_Initialize()
    Dim InfoFile As InfoFile
    Dim AbortFile As AbortFile
    Dim crkUrl As crkUrl
End Sub

Public Sub DownloadFile(ByVal UrlWEB As String, ByVal DimensioneFile As Long, ByVal localfile As String, ByVal ByteIniziale As Long, ByVal BytesDaLeggere As Integer)
Dim retValUrlFile As Long
Dim retValFilePointer As Long
Dim retValReadFile As Boolean
Dim ByteLetti As Long

Dim readBuf As String
readBuf = Space$(BytesDaLeggere)

ByteLetti = 0
ByteRecuperati = 0

UrlWEB = ConvertiSeparatoreURL(UrlWEB)

AbortFile.UrlWEB = ""
AbortFile.ByteRecuperati = 0
  
retValUrlFile = InternetOpenUrl(m_RetValSessione, UrlWEB, vbNullString, 0, INTERNET_FLAG_EXISITING_CONNECT, 0)

'[Controlla se deve iniziare un download o deve recuperare un download precedente]
If ByteIniziale > 0 Then
    retValFilePointer = InternetSetFilePointer(retValUrlFile, ByteIniziale, 0, INTERNET_FILE_MOVE_CURRENT, 0)
    If retValFilePointer = 0 Then
        MsgBox "Errore nel download del file.", vbCritical, "Errore ripristino download"
        InternetCloseHandle retValUrlFile
        InternetCloseHandle m_RetValSessione
        m_RetValSessione = 0
    Else
        ByteRecuperati = retValFilePointer
    End If
End If

If retValUrlFile <> 0 Then
    'Inizio della lettura e del Download del file remoto
     Do While m_StopDownload = False
        'readBuf = ""
        
        DoEvents
        If m_StopDownload = True Then Exit Do
        DoEvents
        
        retValReadFile = InternetReadFile(retValUrlFile, readBuf, Len(readBuf), ByteLetti)
        
        DoEvents
        If m_StopDownload = True Then Exit Do
        DoEvents
        
        If (ByteLetti > 0) And (retValReadFile = True) Then
            'scrive nel file locale i bytes remoti letti
            DoEvents
            Open localfile For Binary As #1
                Seek #1, FileLen(localfile) + 1
                Put #1, , readBuf
            Close #1
        Else
            DoEvents
            Exit Do
        End If
                        
        DoEvents
        If m_StopDownload = True Then Exit Do
        DoEvents
        
        ByteRecuperati = ByteRecuperati + ByteLetti
                                                
        DoEvents
        If m_StopDownload = True Then Exit Do
        DoEvents
        
        If retValReadFile = False Then
            MsgBox "Errore durante il download. Impossibile recuperare il file. ", vbCritical, "Download error:"
            InternetCloseHandle retValUrlFile
            InternetCloseHandle m_RetValSessione
            m_RetValSessione = 0
            Exit Sub
        End If
        
        DoEvents
        If m_StopDownload = True Then Exit Do
        DoEvents
        
        'scatena l'evento ogni qualvolta sono stato recuperati dei bytes
        RaiseEvent Ricevuti(ByteRecuperati)
    Loop
    
    InternetCloseHandle retValUrlFile
    InternetCloseHandle m_RetValSessione
    m_RetValSessione = 0
        
    If m_StopDownload = False Then
        MsgBox "Il Download  stato completato.", vbInformation, "Download Terminato."
        m_StopDownload = True
        m_UrlFileWEB = ""
        m_ByteRecuperatiSuAbort = 0
    Else
        InfoAbort localfile, UrlWEB
        MsgBox "Operazione di download annullata. Sar possibile riprendere il processo in un secondo momento", vbExclamation, "Operazione annullata:"
    End If
Else
    MsgBox "Impossibile aprire l'URL per il download del file.", vbInformation, "Attenzione:"
    'm_StopDownload = True
End If

End Sub
Private Function InfoAbort(ByVal localfile As String, strUrl As String)
    m_UrlFileWEB = strUrl
    m_ByteRecuperatiSuAbort = FileLen(localfile)
End Function
Public Function OttieniInformazioniRemote(ByVal UrlWEB As String, ByVal User As String, ByVal Password As String) As Boolean
'Dichiarazione delle variabili
Dim urlRisolto As crkUrl
Dim Buffer As String * 1024
Dim lBuffer As Long

Dim RetValConnetti As Long
Dim RetValOpenRequest As Long
Dim RetValQueryInfo  As Long
Dim retValSendRequest As Long

Dim strTemp As String

If User = "" Then User = vbNullString
If Password = "" Then Password = vbNullString
RisolviUrl UrlWEB, urlRisolto

If m_RetValSessione = 0 Then
    m_RetValSessione = Connetti
End If

RetValConnetti = InternetConnect(m_RetValSessione, urlRisolto.Dominio, 0, User, Password, 3, 0, 0)
RetValOpenRequest = HttpOpenRequest(RetValConnetti, "HEAD", urlRisolto.Pathfile, "HTTP/1.0", vbNullString, 0, INTERNET_FLAG_RELOAD, 0)
  
If RetValOpenRequest <> 0 Then
    Buffer = Space(1024)
    lBuffer = Len(Buffer)
    retValSendRequest = HttpSendRequest(RetValOpenRequest, vbNullString, 0, 0, 0)
    RetValQueryInfo = HttpQueryInfo(RetValOpenRequest, 22, ByVal Buffer, lBuffer, 0)
    
    'se il valore di ritorno di HttpQueryInfo  diverso da zero il file remoto esiste
    If RetValQueryInfo <> 0 Then
        Dim Pos As Long
        Pos = 0
        'NomeServer
        Pos = InStr(1, Buffer, "Server:", vbBinaryCompare)
        If Pos > 0 Then
            strTemp = Mid(Buffer, Pos + (Len("Server:") + 1))
            Pos = InStr(1, strTemp, Chr(13), vbBinaryCompare)
            InfoFile.Server = Left(strTemp, Pos - 1)
        End If
        'data ultimo aggiornamento
        Pos = InStr(1, Buffer, "Last-Modified:", vbBinaryCompare)
        If Pos > 0 Then
            strTemp = Mid(Buffer, Pos + (Len("Last-Modified:") + 1))
            Pos = InStr(1, strTemp, Chr(13), vbBinaryCompare)
            InfoFile.UltimaModifica = Left(strTemp, Pos - 1)
        End If
        'dimensione del file
        Pos = InStr(1, Buffer, "Content-Length:", vbBinaryCompare)
        If Pos > 0 Then
            Dim DimensioneFile As Long
            strTemp = Mid(Buffer, Pos + (Len("Content-Length:") + 1))
            Pos = InStr(1, strTemp, Chr(13), vbBinaryCompare)
            InfoFile.Dimensione = Left(strTemp, Pos - 1)
        End If
                          
        If InStr(1, Buffer, "HTTP/1.1 404") Then
            OttieniInformazioniRemote = False
        Else
            OttieniInformazioniRemote = True
        End If
    End If
End If
End Function
'Funzioni e SubRoutine di Aiuto
Private Function RisolviUrl(ByVal strUrl As String, ByRef crkUrl As crkUrl) As Boolean
    Dim Pos&
    
    strUrl = EliminaHTTP(strUrl)
    
    If InStr(1, strUrl, "/", vbBinaryCompare) Then
        Pos = InStr(1, strUrl, "/", vbBinaryCompare)
        crkUrl.Pathfile = Right(strUrl, Len(strUrl) - Pos + 1)
        crkUrl.Dominio = Left(strUrl, Pos - 1)
    ElseIf InStr(1, strUrl, "\", vbBinaryCompare) Then
        Pos = InStr(1, strUrl, "\", vbBinaryCompare)
        crkUrl.Pathfile = Right(strUrl, Len(strUrl) - Pos + 1)
        crkUrl.Dominio = Left(strUrl, Pos - 1)
    End If
End Function
Private Function Connetti() As Long
    Connetti = InternetOpen(Agent, INTERNET_OPEN_TYPE_PRECONFIG, vbNullString, vbNullString, 0)
End Function
Private Function EliminaHTTP(ByVal UrlWEB As String) As String
    Dim strHttp As String
    strHttp = UCase(Left(UrlWEB, 7))
    If strHttp = "HTTP://" Or strHttp = "HTTP:\\" Then
        EliminaHTTP = Right(UrlWEB, Len(UrlWEB) - 7)
    Else
        EliminaHTTP = ""
    End If
End Function
Private Function ConvertiSeparatoreURL(ByVal UrlWEB As String) As String
    Dim I As Integer
    Dim strTemp As String
    For I = 1 To Len(UrlWEB)
        strTemp = strTemp & Mid(UrlWEB, I, 1)
        If Right(strTemp, 1) = "\" Then
            strTemp = Left(strTemp, I - 1) & "/"
        End If
    Next I
    ConvertiSeparatoreURL = strTemp
End Function
Public Function RisolviNome(ByVal Risolvere As String) As String
    If Risolvere = "" Then Exit Function
    Dim Car$
    Dim N%
    Dim strUrl As String
    Dim Separator As String
    If InStr(1, Risolvere, "http", vbBinaryCompare) Then
        strUrl = EliminaHTTP(Risolvere)
    Else
        strUrl = Risolvere
    End If
    
    If InStr(1, Risolvere, "\", vbBinaryCompare) <> 0 Then
        Separator = "\"
    Else
        Separator = "/"
    End If
    Do While InStr(1, Car, Separator, vbTextCompare) = False
        N = N + 1
        Car = Right(Risolvere, N)
        DoEvents
    Loop
    RisolviNome = Right(Risolvere, N - 1)
End Function
'Propriet di lettura scrittura della classe
Public Property Get Server() As String
    Server = InfoFile.Server
End Property
Public Property Get DimensioneFileRemoto() As String
    DimensioneFileRemoto = InfoFile.Dimensione
End Property
Public Property Get UltimaModificaFileRemoto() As String
    UltimaModificaFileRemoto = InfoFile.UltimaModifica
End Property
Public Property Get FermaDownload() As Boolean
    FermaDownload = m_StopDownload
End Property
Public Property Let FermaDownload(ByVal newBoolean As Boolean)
    m_StopDownload = newBoolean
End Property
Public Property Get AbortFile_ByteRecuperati() As Long
    AbortFile_ByteRecuperati = m_ByteRecuperatiSuAbort
End Property
Public Property Get AbortFile_UrlWEB() As String
    AbortFile_UrlWEB = m_UrlFileWEB
End Property
