Attribute VB_Name = "PL_EsistenzaFile"
Option Explicit
Public Type SECURITY_ATTRIBUTES
        nLength As Long
        lpSecurityDescriptor As Long
        bInheritHandle As Long
End Type

Public Declare Function CopyFile Lib "kernel32" Alias "CopyFileA" (ByVal lpExistingFileName As String, ByVal lpNewFileName As String, ByVal bFailIfExists As Long) As Long
Public Declare Function CreateDirectory Lib "kernel32" Alias "CreateDirectoryA" (ByVal lpPathName As String, lpSecurityAttributes As SECURITY_ATTRIBUTES) As Long
Public Declare Function MoveFile Lib "kernel32" Alias "MoveFileA" (ByVal lpExistingFileName As String, ByVal lpNewFileName As String) As Long
Public Declare Function MoveFileEx Lib "kernel32" Alias "MoveFileExA" (ByVal lpExistingFileName As String, ByVal lpNewFileName As String, ByVal dwFlags As Long) As Long
Public Declare Function DeleteFile Lib "kernel32" Alias "DeleteFileA" (ByVal lpFileName As String) As Long

Dim Ret&
Dim Supporto&
Public Function CreaCartella(NomeCartella As String) As Boolean
    Dim A As SECURITY_ATTRIBUTES
    With A
        .bInheritHandle = True
        .nLength = Len(A)
        .lpSecurityDescriptor = 0
    End With
    Ret = CreateDirectory(NomeCartella, A)
    If Ret > 0 Then
        CreaCartella = True
    Else
        CreaCartella = False
    End If
End Function
Public Function CopiaF(Origine As String, Destinazione As String) As Boolean
 Ret = CopyFile(Origine, Destinazione, Supporto)
 If Ret > 0 Then
    CopiaF = False
 Else
    CopiaF = True
 End If
End Function
Public Function MuoviF(Origine As String, Destinazione As String) As Boolean
    Ret = MoveFile(Origine, Destinazione)
    If Ret > 0 Then
        MuoviF = True
    Else
        MuoviF = False
    End If
End Function
Public Function CancellaF(strFile As String) As Boolean
    Ret = DeleteFile(strFile)
    If Ret > 0 Then
        CancellaF = True
    Else
        CancellaF = False
    End If
End Function
' CONTROLLA SE ESISTE UN FILE
Public Function EsisteF(Pathfile As String) As Boolean
Dim File_
Set File_ = CreateObject("Scripting.FileSystemObject")
    EsisteF = File_.fileexists(Pathfile)
End Function
'COPIA CARTELLA
Public Function CopiaC(PathSource As String, PathDest As String)
    Dim Cart
    Set Cart = CreateObject("Scripting.FileSystemObject")
    Cart.copyfolder PathSource, PathDest, True
End Function
'CANCELLA UNA CARTELLA
Public Function DeleteC(pathC As String)
    Dim File_
    Set File_ = CreateObject("Scripting.FileSystemObject")
    File_.deletefolder pathC, True
End Function
Public Function DeleteF(pathF As String)
    Dim File_
    Set File_ = CreateObject("scripting.filesystemobject")
    File_.DeleteFile pathF, True
End Function

' SPOSTA UNA CARTELLA
Public Function SpostaC(Origine As String, Destinazione As String)
    Dim File_
    Set File_ = CreateObject("Scripting.FileSystemObject")
    File_.MoveFolder Origine, Destinazione
End Function

